local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.IncomingDamage2 = a.incomingDamage2()
	x.TimeToDie = s.TimeToDie("target") or 10
	x.Chi = s.Power("player", SPELL_POWER_CHI )
	x.MaxChi = s.MaxPower("player", SPELL_POWER_CHI)
	x.Energy = s.Power("player", SPELL_POWER_ENERGY )
	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown() + x.Lag
	x.Spec = s.TalentMastery()
	x.ActiveEnemies = a.getNumEnemies()
	x.MaxHealth = s.MaxHealth("player")
	if x.CombatStart == 0 or x.CombatStart == nil then
		x.Time = 0
	else
		x.Time = GetTime() - x.CombatStart
	end
	a.Flash("Legacy of the Emperor")
	a.Flash("Spear Hand Strike", "Paralysis", "Leg Sweep as Interrupt") -- interrupt casters
	a.Flash("fortifying_brew,if=incoming_damage_2>health.max*0.5") -- emergency CD for every spec
	a.FlashAll("Nimble Brew", "Tiger's Lust", "Charging Ox Wave", "Dampen Harm", "Diffuse Magic", "Detox") -- Talents
	if x.Spec == 1 then
		-- Brewmaster
		x.ShuffleRemains = s.BuffDuration(115307--[[Shuffle]], "player")
		x.EnergyPerSecond = a.energyRegeneration()
		x.TimeToMax = (100 - x.Energy) / x.EnergyPerSecond
		x.StaggerAmount = a.getStagger()
		x.KegSmashCDRemains = s.SpellCooldown(121253--[[Keg Smash]])
		a.Flash("stance,choose=sturdy_ox")
		a.FlashAll("Clash", "Roll") -- if we are not in range, use these
		a.Flash("Provoke") -- taunt if tanking and not keeping aggro
		a.Flash("Dizzying Haze") -- something to do at range, while kiting or to set up a Breath of Fire
		a.Flash("black_ox_statue")
		if not x.InCombat and x.EnemyDetected then
			a.FlashAll("flask,type=earth",
					   "mountains_potion")
		end
		if x.ActiveEnemies < 3 then
			a.Flash("auto_attack",
					"invoke_xuen,if=talent.invoke_xuen.enabled",
					"elusive_brew",
					-- Purify off stagger, being more liberal the longer time remains on shuffle.
					"purifying_brew,if=stagger.amount&stagger.amount%health.max*100>20-buff.shuffle.remains",
					"guard,if=buff.shuffle.remains>6&incoming_damage_2>health.max*0.5",
					"blackout_kick,if=buff.shuffle.remains<=1.5",
					"blackout_kick,if=chi=chi.max&energy.time_to_max<=2",
					"blackout_kick,if=chi>=chi.max-1&cooldown.keg_smash.remains<=1",
					"keg_smash",
					"expel_harm,if=incoming_damage_2>health.max*0.3",
					"jab,if=energy.time_to_max<=1",
					"tiger_palm,if=buff.tiger_power.down",
					"chi_burst,if=talent.chi_burst.enabled",
					"chi_wave,if=talent.chi_wave.enabled",
					"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking",
					"blackout_kick,if=chi=chi.max",
					"jab,if=energy+energy.regen*cooldown.keg_smash.remains>=80",
					"tiger_palm")
		else
			a.Flash("auto_attack",
					"invoke_xuen,if=talent.invoke_xuen.enabled",
					"elusive_brew",
					-- Purify off stagger, being more liberal the longer time remains on shuffle.
					"purifying_brew,if=stagger.amount&stagger.amount%health.max*100>20-buff.shuffle.remains",
					"guard,if=buff.shuffle.remains>6&incoming_damage_2>health.max*0.5",
					"blackout_kick,if=buff.shuffle.remains<=1.5",
					"blackout_kick,if=chi=chi.max&energy.time_to_max<=2",
					"blackout_kick,if=chi>=chi.max-1&cooldown.keg_smash.remains<=1",
					"keg_smash",
					"expel_harm,if=incoming_damage_2>health.max*0.3",
					"leg_sweep",
					"rushing_jade_wind,if=talent.rushing_jade_wind.enabled",
					"spinning_crane_kick,if=!talent.rushing_jade_wind.enabled&energy.time_to_max<=1",
					"tiger_palm,if=buff.tiger_power.down",
					"chi_burst,if=talent.chi_burst.enabled",
					"chi_wave,if=talent.chi_wave.enabled",
					"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking",
					"breath_of_fire",
					"blackout_kick,if=chi=chi.max",
					"jab,if=talent.rushing_jade_wind.enabled&energy.time_to_max<cooldown.rushing_jade_wind.remains&energy.time_to_max<cooldown.keg_smash.remains",
					"spinning_crane_kick,if=!talent.rushing_jade_wind.enabled&energy+energy.regen*cooldown.keg_smash.remains>=80",
					"tiger_palm")
		end
	elseif x.Spec == 2 then
		-- Mistweaver
		x.Bloodlust = a.Bloodlust()
		x.BuffLucidityRemains = s.BuffDuration(137288--[[Lucidity]], "player")
		x.BuffMuscleMemoryRemains = s.BuffDuration(139597--[[Muscle Memory]], "player")
		a.Flash("stance,choose=wise_serpent")
		a.Flash("jade_serpent_statue")
		a.Flash("uplift")
		a.Flash("chi_brew,if=talent.chi_brew.enabled&chi<=2&((charges=1&recharge_time<=10)|charges=2|target.time_to_die<charges*10)")
		a.Flash("auto_attack",
				"crackling_jade_lightning,if=buff.bloodlust.up&buff.lucidity.up",
				"tiger_palm,if=buff.muscle_memory.up&buff.lucidity.up",
				"jab,if=buff.lucidity.up",
				"renewing_mist",
				"tiger_palm,if=buff.muscle_memory.up&!buff.tiger_power.up",
				"blackout_kick,if=buff.muscle_memory.up&chi>1&!buff.serpents_zeal.up",
				"tiger_palm,if=buff.muscle_memory.up",
				"chi_wave,if=talent.chi_wave.enabled",
				"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking")
				
	elseif x.Spec == 3 then
		-- Windwalker
		x.EnergyPerSecond = a.energyRegeneration()
		x.TimeToMax = (100 - x.Energy) / x.EnergyPerSecond
		x.Bloodlust = a.Bloodlust()
		x.TrinketProcAgilityRemains = s.BuffDuration({148903--[[Vicious]],
											   146308--[[Dextrous]],
											   148896--[[Ferocity]],
											   146310--[[Restless Agility]],
											   126554--[[Agile]],
											   138699--[[Superluminal]],
											   138938--[[Juju Madness]],
											   138699--[[Superluminal]],
											   }, "player")
		x.DebuffRisingSunKickRemains = s.MyDebuffDuration(130320--[[Rising Sun Kick]], "target", nil, false, false, true)
		x.BuffSerenityRemains = s.BuffDuration(152173--[[Serenity]], "player")
		x.TalentSerenityEnabled = s.HasTalent(152173--[[Serenity]])
		x.TalentChiExplosionEnabled = s.HasTalent(152174--[[Chi Explosion]])
		
		x.CanTigerPalm = (x.Chi >= 1 or s.BuffDuration(118864--[[Combo Breaker: Tiger Palm]], "player", nil, false, false, true) > x.GCD)
		x.CanBlackoutKick = not x.TalentChiExplosionEnabled and (x.Chi >= 2 or s.BuffDuration(116768--[[Combo Breaker: Blackout Kick]], "player", nil, false, false, true) > x.GCD)
		
		x.BuffTigerPowerRemains = s.BuffDuration(125359--[[Tiger Power]], "player", nil, false, false, true)
		x.BuffTigereyeBrewRemains = s.BuffDuration(116740--[[Tigereye Brew]], "player", nil, false, false, true)
		x.BuffTigereyeBrewStack = s.BuffStack(125195--[[Tigereye Brew]], "player", nil, false, false, true)
		a.Flash("stance,choose=fierce_tiger")
		a.Flash("Legacy of the White Tiger")
		a.Flash("Flying Serpent Kick", "Roll")
		if not x.InCombat and x.EnemyDetected then
			a.FlashAll("flask,type=spring_blossoms",
			           "potion,name=draenic_agility")
		end
		if x.ActiveEnemies >= 3 and not s.Channeling(113656--[[Fists of Fury]], "player") then
			x.TalentRushingJadeWindEnabled = s.HasTalent(116847--[[Rushing Jade Wind]])
			a.Flash("auto_attack",
					"invoke_xuen,if=talent.invoke_xuen.enabled&time>5",
--					"chi_sphere,if=talent.power_strikes.enabled&buff.chi_sphere.react&chi<4",
					"potion,name=draenic_agility,if=buff.serenity.up|(!talent.serenity.enabled&trinket.proc.agility.react)",
					"blood_fury,if=buff.tigereye_brew_use.up|target.time_to_die<18",
					"berserking,if=buff.tigereye_brew_use.up|target.time_to_die<18",
					"arcane_torrent,if=buff.tigereye_brew_use.up|target.time_to_die<18",
--			        "synapse_springs",
					"chi_brew,if=chi.max-chi>=2&((charges=1&recharge_time<=10)|charges=2|target.time_to_die<charges*10)&buff.tigereye_brew.stack<=16",
					"tiger_palm,if=buff.tiger_power.remains<=3",
					"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack=20",
					"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=10&buff.serenity.up",
					"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=10&cooldown.fists_of_fury.up&chi>=3&debuff.rising_sun_kick.up&buff.tiger_power.up",
					"tigereye_brew,if=talent.hurricane_strike.enabled&buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=10&cooldown.hurricane_strike.up&chi>=3&debuff.rising_sun_kick.up&buff.tiger_power.up",
					"tigereye_brew,if=buff.tigereye_brew_use.down&chi>=2&(buff.tigereye_brew.stack>=16|target.time_to_die<40)&debuff.rising_sun_kick.up&buff.tiger_power.up",
					"rising_sun_kick,if=(debuff.rising_sun_kick.down|debuff.rising_sun_kick.remains<3)",
					"tiger_palm,if=buff.tiger_power.down&debuff.rising_sun_kick.remains>1&energy.time_to_max>1",
					"serenity,if=talent.serenity.enabled&chi>=2&buff.tiger_power.up&debuff.rising_sun_kick.up",
					"chi_explosion,if=chi>=4",
					"rushing_jade_wind",
					"rising_sun_kick,if=!talent.rushing_jade_wind.enabled&chi=chi.max",
					"fists_of_fury,if=talent.rushing_jade_wind.enabled&energy.time_to_max>cast_time&buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&!buff.serenity.remains",
					"touch_of_death,if=target.health.percent<10",
					"hurricane_strike,if=talent.rushing_jade_wind.enabled&talent.hurricane_strike.enabled&energy.time_to_max>cast_time&buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&buff.energizing_brew.down",
					"zen_sphere,cycle_targets=1,if=!dot.zen_sphere.ticking",
					"chi_wave,if=energy.time_to_max>2&buff.serenity.down",
					"chi_burst,if=talent.chi_burst.enabled&energy.time_to_max>2&buff.serenity.down",
					"blackout_kick,if=talent.rushing_jade_wind.enabled&!talent.chi_explosion.enabled&(buff.combo_breaker_bok.react|buff.serenity.up)",
					"tiger_palm,if=talent.rushing_jade_wind.enabled&buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2",
					"blackout_kick,if=talent.rushing_jade_wind.enabled&!talent.chi_explosion.enabled&chi.max-chi<2",
					"spinning_crane_kick,if=!talent.rushing_jade_wind.enabled",
					"jab,if=talent.rushing_jade_wind.enabled&chi.max-chi>=2")
		elseif not s.Channeling(113656--[[Fists of Fury]], "player") then
			a.Flash("auto_attack",
					"invoke_xuen,if=talent.invoke_xuen.enabled&time>5",
--					"chi_sphere,if=talent.power_strikes.enabled&buff.chi_sphere.react&chi<4",
					"potion,name=draenic_agility,if=buff.serenity.up|(!talent.serenity.enabled&trinket.proc.agility.react)",
					"blood_fury,if=buff.tigereye_brew_use.up|target.time_to_die<18",
					"berserking,if=buff.tigereye_brew_use.up|target.time_to_die<18",
					"arcane_torrent,if=buff.tigereye_brew_use.up|target.time_to_die<18",
--			        "synapse_springs",
					"chi_brew,if=chi.max-chi>=2&((charges=1&recharge_time<=10)|charges=2|target.time_to_die<charges*10)&buff.tigereye_brew.stack<=16",
					"tiger_palm,if=buff.tiger_power.remains<=3",
					"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack=20",
					"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=10&buff.serenity.up",
					"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=10&cooldown.fists_of_fury.up&chi>=3&debuff.rising_sun_kick.up&buff.tiger_power.up",
					"tigereye_brew,if=talent.hurricane_strike.enabled&buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=10&cooldown.hurricane_strike.up&chi>=3&debuff.rising_sun_kick.up&buff.tiger_power.up",
					"tigereye_brew,if=buff.tigereye_brew_use.down&chi>=2&(buff.tigereye_brew.stack>=16|target.time_to_die<40)&debuff.rising_sun_kick.up&buff.tiger_power.up",
					"rising_sun_kick,if=(debuff.rising_sun_kick.down|debuff.rising_sun_kick.remains<3)",
					"tiger_palm,if=buff.tiger_power.down&debuff.rising_sun_kick.remains>1&energy.time_to_max>1",
					"serenity,if=talent.serenity.enabled&chi>=2&buff.tiger_power.up&debuff.rising_sun_kick.up",
					"fists_of_fury,if=energy.time_to_max>cast_time&buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&!buff.serenity.remains",
					"touch_of_death,if=target.health.percent<10",
					"hurricane_strike,if=talent.hurricane_strike.enabled&energy.time_to_max>cast_time&buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&buff.energizing_brew.down",
					"energizing_brew,if=cooldown.fists_of_fury.remains>6&(!talent.serenity.enabled|(!buff.serenity.remains&cooldown.serenity.remains>4))&energy+energy.regen*gcd<50",
					"rising_sun_kick,if=!talent.chi_explosion.enabled",
					"chi_wave,if=energy.time_to_max>2&buff.serenity.down",
					"chi_burst,if=talent.chi_burst.enabled&energy.time_to_max>2&buff.serenity.down",
					"zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down",
					"blackout_kick,if=!talent.chi_explosion.enabled&(buff.combo_breaker_bok.react|buff.serenity.up)",
					"chi_explosion,if=talent.chi_explosion.enabled&chi>=3&buff.combo_breaker_ce.react",
					"tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2",
					"blackout_kick,if=!talent.chi_explosion.enabled&chi.max-chi<2",
					"chi_explosion,if=talent.chi_explosion.enabled&chi>=3",
					"jab,if=chi.max-chi>=2")
		end
	end
end)
